' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : K.Yakushinji
'
'  : 2007/02/01 
' -----------------------------------------------------------------

Public Class frmDidoTest

    Private Const MAXBIT = 31
    Private BitArray(MAXBIT) As Integer
    Private BitCnt As Integer

    Private Sub frmDidoTest_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim i As Integer
        Dim Bit As Integer

        'gp̊mF
        If My.Forms.frmLicence.ShowDialog() <> Windows.Forms.DialogResult.Yes Then
            End
        End If

        '`FbN{bNX
        For i = 0 To MAXBIT
            Me.Controls("chkRead" + i.ToString).Enabled = False
            Me.Controls("chkWrite" + i.ToString).Enabled = False
        Next

        'DeviceTypȅ
        cmbDeviceType.Items.Clear()
        cmbDeviceType.Items.Add("FIO01")
        cmbDeviceType.Items.Add("FV1000/FV1100")
        cmbDeviceType.SelectedIndex = 0

        '_̏
        BitCnt = 0

        'rbgf[^쐬
        Bit = 2
        For i = 0 To MAXBIT
            If i <> MAXBIT Then
                BitArray(i) = (Bit ^ i)
            Else
                BitArray(i) = -1 * (Bit ^ i)
            End If
        Next i

    End Sub

    'Open{^NbNꂽꍇ
    Private Sub btnOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpen.Click
        
        Dim iDevID As Integer
        Dim i As Integer

        Try

            'DeviceTypeݒ
            Select Case cmbDeviceType.SelectedIndex
                Case 0
                    AxFvxDido1.DeviceType = FVXCOMDIDOLib.DIDO_DEVICE_TYPE.deviceFIO01
                    AxFvxDido1.DeviceID = -1
                    BitCnt = 15
                Case 1
                    AxFvxDido1.DeviceType = FVXCOMDIDOLib.DIDO_DEVICE_TYPE.deviceMPC7664
                    AxFvxDido1.DeviceID = -1
                    BitCnt = 31
                Case Else
                    '------------
            End Select

            'Opens
            AxFvxDido1.Open()
            'DeviceID̎擾A\
            AxFvxDido1.GetOpenedDeviceID(iDevID)
            txtDevID.Text = iDevID

            'OpenA`FbN{bNXL
            For i = 0 To MAXBIT
                '`FbN{bNX
                If i <= BitCnt Then
                    Me.Controls("chkRead" + i.ToString).Enabled = True
                    Me.Controls("chkWrite" + i.ToString).Enabled = True
                Else
                    Me.Controls("chkRead" + i.ToString).Enabled = False
                    Me.Controls("chkWrite" + i.ToString).Enabled = False
                End If
            Next

        Catch

            Dim intErr As Integer
            AxFvxDido1.GetErrReport(intErr)
            MsgBox("G[܂(" + intErr.ToString + ")", MsgBoxStyle.OkOnly, "Error")

        End Try
    End Sub

    'Close{^NbNꂽꍇ
    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click

        Dim i As Integer

        Try

            'DidõN[Y
            AxFvxDido1.Close()
            txtDevID.Text = ""

            '`FbN{bNX@x
            For i = 0 To MAXBIT
                Me.Controls("chkRead" + i.ToString).Enabled = False
                Me.Controls("chkWrite" + i.ToString).Enabled = False
            Next

        Catch

            Dim intErr As Integer
            AxFvxDido1.GetErrReport(intErr)
            MsgBox("G[܂(" + intErr.ToString + ")", MsgBoxStyle.OkOnly, "Error")

        End Try

    End Sub

    'Read{^NbNꂽꍇ
    Private Sub btnRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead.Click

        Dim iBitPattern As Integer
        Dim cTemp As New CheckBox
        Dim i As Integer

        iBitPattern = 0

        Try

            'Reads
            AxFvxDido1.Read(iBitPattern)
            '`
            For i = 0 To BitCnt
                cTemp = Me.Controls("chkRead" + i.ToString)
                If 0 < (BitArray(i) And iBitPattern) Then
                    cTemp.Checked = True
                Else
                    cTemp.Checked = False
                End If
            Next i

        Catch

            Dim intErr As Integer
            AxFvxDido1.GetErrReport(intErr)
            MsgBox("G[܂(" + intErr.ToString + ")", MsgBoxStyle.OkOnly, "Error")

        End Try

    End Sub

    'Write{^NbNꂽꍇ
    Private Sub btnWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWrite.Click

        Dim iBitPattern As Integer
        Dim i As Long
        Dim cTemp As New CheckBox

        Try

            'Initial
            iBitPattern = 0

            '`FbN{bNX̓ǂݍ
            For i = 0 To BitCnt
                cTemp = Me.Controls("chkWrite" + i.ToString)
                If cTemp.Checked Then
                    iBitPattern = (iBitPattern Or BitArray(i))
                End If
            Next i

            'o
            AxFvxDido1.Write(iBitPattern)
        Catch

            Dim intErr As Integer
            AxFvxDido1.GetErrReport(intErr)
            MsgBox("G[܂(" + intErr.ToString + ")", MsgBoxStyle.OkOnly, "Error")

        End Try

    End Sub

    'Interrupt{^NbNꂽꍇ
    Private Sub btnInterrupt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInterrupt.Click

        Dim iBitPattern As Integer
        Dim cBitPattern As Integer
        Dim i As Integer
        Dim cTemp As New CheckBox

        iBitPattern = 0

        Try

            'ReadInterrupt
            AxFvxDido1.ReadInterrupt(iBitPattern)

            cBitPattern = iBitPattern
            '`
            For i = 0 To BitCnt
                cTemp = Me.Controls("chkRead" + i.ToString)
                If 0 < (BitArray(i) And cBitPattern) Then
                    cTemp.Checked = True
                Else
                    cTemp.Checked = False
                End If
            Next i
        Catch

            Dim intErr As Integer
            AxFvxDido1.GetErrReport(intErr)
            MsgBox("G[܂(" + intErr.ToString + ")", MsgBoxStyle.OkOnly, "Error")

        End Try
    End Sub
End Class
